// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_ford_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice
#include "dbw_ford_msgs/msg/detail/misc_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `cmd`
#include "dbw_ford_msgs/msg/detail/turn_signal__functions.h"
// Member `pbrk`
#include "dbw_ford_msgs/msg/detail/parking_brake_cmd__functions.h"

bool
dbw_ford_msgs__msg__MiscCmd__init(dbw_ford_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_ford_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // cmd
  if (!dbw_ford_msgs__msg__TurnSignal__init(&msg->cmd)) {
    dbw_ford_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // pbrk
  if (!dbw_ford_msgs__msg__ParkingBrakeCmd__init(&msg->pbrk)) {
    dbw_ford_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  return true;
}

void
dbw_ford_msgs__msg__MiscCmd__fini(dbw_ford_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // cmd
  dbw_ford_msgs__msg__TurnSignal__fini(&msg->cmd);
  // pbrk
  dbw_ford_msgs__msg__ParkingBrakeCmd__fini(&msg->pbrk);
}

dbw_ford_msgs__msg__MiscCmd *
dbw_ford_msgs__msg__MiscCmd__create()
{
  dbw_ford_msgs__msg__MiscCmd * msg = (dbw_ford_msgs__msg__MiscCmd *)malloc(sizeof(dbw_ford_msgs__msg__MiscCmd));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_ford_msgs__msg__MiscCmd));
  bool success = dbw_ford_msgs__msg__MiscCmd__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_ford_msgs__msg__MiscCmd__destroy(dbw_ford_msgs__msg__MiscCmd * msg)
{
  if (msg) {
    dbw_ford_msgs__msg__MiscCmd__fini(msg);
  }
  free(msg);
}


bool
dbw_ford_msgs__msg__MiscCmd__Sequence__init(dbw_ford_msgs__msg__MiscCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_ford_msgs__msg__MiscCmd * data = NULL;
  if (size) {
    data = (dbw_ford_msgs__msg__MiscCmd *)calloc(size, sizeof(dbw_ford_msgs__msg__MiscCmd));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_ford_msgs__msg__MiscCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_ford_msgs__msg__MiscCmd__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_ford_msgs__msg__MiscCmd__Sequence__fini(dbw_ford_msgs__msg__MiscCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_ford_msgs__msg__MiscCmd__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_ford_msgs__msg__MiscCmd__Sequence *
dbw_ford_msgs__msg__MiscCmd__Sequence__create(size_t size)
{
  dbw_ford_msgs__msg__MiscCmd__Sequence * array = (dbw_ford_msgs__msg__MiscCmd__Sequence *)malloc(sizeof(dbw_ford_msgs__msg__MiscCmd__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_ford_msgs__msg__MiscCmd__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_ford_msgs__msg__MiscCmd__Sequence__destroy(dbw_ford_msgs__msg__MiscCmd__Sequence * array)
{
  if (array) {
    dbw_ford_msgs__msg__MiscCmd__Sequence__fini(array);
  }
  free(array);
}
