// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_ford_msgs:msg/BrakeInfoReport.idl
// generated code does not contain a copyright notice
#include "dbw_ford_msgs/msg/detail/brake_info_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `brake_pedal_qf`
#include "dbw_ford_msgs/msg/detail/quality_factor__functions.h"
// Member `hsa`
#include "dbw_ford_msgs/msg/detail/hill_start_assist__functions.h"
// Member `parking_brake`
#include "dbw_ford_msgs/msg/detail/parking_brake__functions.h"

bool
dbw_ford_msgs__msg__BrakeInfoReport__init(dbw_ford_msgs__msg__BrakeInfoReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_ford_msgs__msg__BrakeInfoReport__fini(msg);
    return false;
  }
  // brake_torque_request
  // brake_torque_actual
  // wheel_torque_actual
  // accel_over_ground
  // brake_pedal_qf
  if (!dbw_ford_msgs__msg__QualityFactor__init(&msg->brake_pedal_qf)) {
    dbw_ford_msgs__msg__BrakeInfoReport__fini(msg);
    return false;
  }
  // hsa
  if (!dbw_ford_msgs__msg__HillStartAssist__init(&msg->hsa)) {
    dbw_ford_msgs__msg__BrakeInfoReport__fini(msg);
    return false;
  }
  // abs_active
  // abs_enabled
  // stab_active
  // stab_enabled
  // trac_active
  // trac_enabled
  // parking_brake
  if (!dbw_ford_msgs__msg__ParkingBrake__init(&msg->parking_brake)) {
    dbw_ford_msgs__msg__BrakeInfoReport__fini(msg);
    return false;
  }
  // stationary
  return true;
}

void
dbw_ford_msgs__msg__BrakeInfoReport__fini(dbw_ford_msgs__msg__BrakeInfoReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // brake_torque_request
  // brake_torque_actual
  // wheel_torque_actual
  // accel_over_ground
  // brake_pedal_qf
  dbw_ford_msgs__msg__QualityFactor__fini(&msg->brake_pedal_qf);
  // hsa
  dbw_ford_msgs__msg__HillStartAssist__fini(&msg->hsa);
  // abs_active
  // abs_enabled
  // stab_active
  // stab_enabled
  // trac_active
  // trac_enabled
  // parking_brake
  dbw_ford_msgs__msg__ParkingBrake__fini(&msg->parking_brake);
  // stationary
}

dbw_ford_msgs__msg__BrakeInfoReport *
dbw_ford_msgs__msg__BrakeInfoReport__create()
{
  dbw_ford_msgs__msg__BrakeInfoReport * msg = (dbw_ford_msgs__msg__BrakeInfoReport *)malloc(sizeof(dbw_ford_msgs__msg__BrakeInfoReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_ford_msgs__msg__BrakeInfoReport));
  bool success = dbw_ford_msgs__msg__BrakeInfoReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_ford_msgs__msg__BrakeInfoReport__destroy(dbw_ford_msgs__msg__BrakeInfoReport * msg)
{
  if (msg) {
    dbw_ford_msgs__msg__BrakeInfoReport__fini(msg);
  }
  free(msg);
}


bool
dbw_ford_msgs__msg__BrakeInfoReport__Sequence__init(dbw_ford_msgs__msg__BrakeInfoReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_ford_msgs__msg__BrakeInfoReport * data = NULL;
  if (size) {
    data = (dbw_ford_msgs__msg__BrakeInfoReport *)calloc(size, sizeof(dbw_ford_msgs__msg__BrakeInfoReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_ford_msgs__msg__BrakeInfoReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_ford_msgs__msg__BrakeInfoReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_ford_msgs__msg__BrakeInfoReport__Sequence__fini(dbw_ford_msgs__msg__BrakeInfoReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_ford_msgs__msg__BrakeInfoReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_ford_msgs__msg__BrakeInfoReport__Sequence *
dbw_ford_msgs__msg__BrakeInfoReport__Sequence__create(size_t size)
{
  dbw_ford_msgs__msg__BrakeInfoReport__Sequence * array = (dbw_ford_msgs__msg__BrakeInfoReport__Sequence *)malloc(sizeof(dbw_ford_msgs__msg__BrakeInfoReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_ford_msgs__msg__BrakeInfoReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_ford_msgs__msg__BrakeInfoReport__Sequence__destroy(dbw_ford_msgs__msg__BrakeInfoReport__Sequence * array)
{
  if (array) {
    dbw_ford_msgs__msg__BrakeInfoReport__Sequence__fini(array);
  }
  free(array);
}
