// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_ford_msgs:msg/SurroundReport.idl
// generated code does not contain a copyright notice
#include "dbw_ford_msgs/msg/detail/surround_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dbw_ford_msgs__msg__SurroundReport__init(dbw_ford_msgs__msg__SurroundReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_ford_msgs__msg__SurroundReport__fini(msg);
    return false;
  }
  // cta_left_alert
  // cta_right_alert
  // cta_left_enabled
  // cta_right_enabled
  // blis_left_alert
  // blis_right_alert
  // blis_left_enabled
  // blis_right_enabled
  // sonar_enabled
  // sonar_fault
  // sonar
  return true;
}

void
dbw_ford_msgs__msg__SurroundReport__fini(dbw_ford_msgs__msg__SurroundReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // cta_left_alert
  // cta_right_alert
  // cta_left_enabled
  // cta_right_enabled
  // blis_left_alert
  // blis_right_alert
  // blis_left_enabled
  // blis_right_enabled
  // sonar_enabled
  // sonar_fault
  // sonar
}

dbw_ford_msgs__msg__SurroundReport *
dbw_ford_msgs__msg__SurroundReport__create()
{
  dbw_ford_msgs__msg__SurroundReport * msg = (dbw_ford_msgs__msg__SurroundReport *)malloc(sizeof(dbw_ford_msgs__msg__SurroundReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_ford_msgs__msg__SurroundReport));
  bool success = dbw_ford_msgs__msg__SurroundReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_ford_msgs__msg__SurroundReport__destroy(dbw_ford_msgs__msg__SurroundReport * msg)
{
  if (msg) {
    dbw_ford_msgs__msg__SurroundReport__fini(msg);
  }
  free(msg);
}


bool
dbw_ford_msgs__msg__SurroundReport__Sequence__init(dbw_ford_msgs__msg__SurroundReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_ford_msgs__msg__SurroundReport * data = NULL;
  if (size) {
    data = (dbw_ford_msgs__msg__SurroundReport *)calloc(size, sizeof(dbw_ford_msgs__msg__SurroundReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_ford_msgs__msg__SurroundReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_ford_msgs__msg__SurroundReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_ford_msgs__msg__SurroundReport__Sequence__fini(dbw_ford_msgs__msg__SurroundReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_ford_msgs__msg__SurroundReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_ford_msgs__msg__SurroundReport__Sequence *
dbw_ford_msgs__msg__SurroundReport__Sequence__create(size_t size)
{
  dbw_ford_msgs__msg__SurroundReport__Sequence * array = (dbw_ford_msgs__msg__SurroundReport__Sequence *)malloc(sizeof(dbw_ford_msgs__msg__SurroundReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_ford_msgs__msg__SurroundReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_ford_msgs__msg__SurroundReport__Sequence__destroy(dbw_ford_msgs__msg__SurroundReport__Sequence * array)
{
  if (array) {
    dbw_ford_msgs__msg__SurroundReport__Sequence__fini(array);
  }
  free(array);
}
